// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on
module eth_f_50g_rx_pp_rptr_gen_async (              
    input   logic               i_clk,
    input   logic   [6:0]       i_ptr,
    output  logic   [0:3][4:0]  o_ptr
);

    always_ff @(posedge i_clk) begin
        case (i_ptr[1:0])
            2'd0 : o_ptr <= {i_ptr[6:2],        i_ptr[6:2], i_ptr[6:2], i_ptr[6:2] - 1'd1};
            2'd1 : o_ptr <= {i_ptr[6:2],        i_ptr[6:2], i_ptr[6:2], i_ptr[6:2]};
            2'd2 : o_ptr <= {i_ptr[6:2],        i_ptr[6:2], i_ptr[6:2], i_ptr[6:2]};
            2'd3 : o_ptr <= {i_ptr[6:2] + 1'd1, i_ptr[6:2], i_ptr[6:2], i_ptr[6:2]};
        endcase
    end
endmodule