// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on
module eth_f_50g_rx_pp_data_rotate_async #(
    parameter WIDTH = 8,
    parameter PREAMBLE_PASSTHROUGH = 0
) (
    input   logic                       i_clk,
    input   logic   [1:0]               i_index,
    input   logic   [0:3][WIDTH-1:0]    i_data,
    output  logic   [0:1][WIDTH-1:0]    o_data,
    output  logic        [WIDTH-1:0]    o_preamble
);

generate
if(PREAMBLE_PASSTHROUGH == 1) begin
    always_ff @(posedge i_clk) begin
        case (i_index)
            2'd0 : o_data   <= {i_data[0], i_data[1]};
            2'd1 : o_data   <= {i_data[1], i_data[2]};
            2'd2 : o_data   <= {i_data[2], i_data[3]};
            2'd3 : o_data   <= {i_data[3], i_data[0]};
        endcase
        case (i_index)
            2'd0 : o_preamble <= i_data[3];
            2'd1 : o_preamble <= i_data[0];
            2'd2 : o_preamble <= i_data[1];
            2'd3 : o_preamble <= i_data[2];
        endcase
    end
end    
else begin
    always_ff @(posedge i_clk) begin
        case (i_index[0])
            1'd0 : o_data <= {i_data[0], i_data[1]};
            1'd1 : o_data <= {i_data[1], i_data[0]};
        endcase
    end
	 assign o_preamble = 64'b0;
end    
endgenerate 

endmodule
