// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


// synthesis translate_off
`timescale 1ns / 1ps
// synthesis translate_on
module eth_f_data_mux_2to1_tx100a  #(
    parameter WIDTH                 = 8,
	parameter EHIP_RATE             = "100G",
	parameter I_DATA_SIZE 			= (EHIP_RATE == "100G") ? 2 : 4,
	parameter O_DATA_SIZE 			= (EHIP_RATE == "100G") ? 1 : 2
) (
    input   logic                       i_clk,
    input   logic                       i_sel,
    input   logic   [0:I_DATA_SIZE-1][WIDTH-1:0]    i_data,
    output  logic   [0:O_DATA_SIZE-1][WIDTH-1:0]    o_data
);
	
    always_ff @(posedge i_clk) begin
        case (i_sel)
            1'd0 : o_data  <= i_data[0: (I_DATA_SIZE/2)-1];
            1'd1 : o_data  <= i_data[(I_DATA_SIZE/2):(I_DATA_SIZE-1)];
        endcase
    end
endmodule