
proc get_design_libraries {} {
  set libraries [dict create]
  dict set libraries f_tile_soft_reset_ctlr_ip_v1           1
  dict set libraries ctf_avmm1_ai_arbiter                   1
  dict set libraries ctf_avmm2_ai_arbiter                   1
  dict set libraries eth_f_hw_auto_tiles                    1
  dict set libraries altera_common_sv_packages              1
  dict set libraries eth_f_1000                             1
  dict set libraries ex_100G                                1
  dict set libraries altera_iopll_1931                      1
  dict set libraries eth_f_sys_pll                          1
  dict set libraries altera_jtag_dc_streaming_191           1
  dict set libraries timing_adapter_1940                    1
  dict set libraries altera_avalon_sc_fifo_1931             1
  dict set libraries altera_avalon_st_bytes_to_packets_1922 1
  dict set libraries altera_avalon_st_packets_to_bytes_1922 1
  dict set libraries altera_avalon_packets_to_master_1922   1
  dict set libraries channel_adapter_1921                   1
  dict set libraries altera_reset_controller_1921           1
  dict set libraries altera_jtag_avalon_master_191          1
  dict set libraries eth_f_jtag_avalon                      1
  dict set libraries altera_in_system_sources_probes_1921   1
  dict set libraries probe8                                 1
  dict set libraries altera_s10_user_rst_clkgate_1945       1
  dict set libraries reset_ip                               1
  dict set libraries systemclk_f_250                        1
  dict set libraries systemclk_f_0                          1
  return $libraries
}

proc get_memory_files {QSYS_SIMDIR} {
  set memory_files [list]
  lappend memory_files "[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/nios2_smg_regfile.hex"]"
  lappend memory_files "[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/rst_ctrl_dram.hex"]"
  lappend memory_files "[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/rst_ctrl_iram.hex"]"
  lappend memory_files "[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/support_logic/eth_f_hw__z1577b_x393_y166_n0.mif"]"
  return $memory_files
}

proc get_common_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
  set design_files [dict create]
  dict set design_files "altera_common_sv_packages::eth_f_package" "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_package.sv"]\"  -work altera_common_sv_packages"
  return $design_files
}

proc get_design_files {USER_DEFINED_COMPILE_OPTIONS USER_DEFINED_VERILOG_COMPILE_OPTIONS USER_DEFINED_VHDL_COMPILE_OPTIONS QSYS_SIMDIR} {
  set design_files [list]
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/maib_filters.sv"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/f_tile_soft_reset_ctlr_ip_v1.sv"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/f_tile_soft_reset_ctlr_if_mux_v1.sv"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_dec8_t1.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/alt_jtagsr_adapt.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                        
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_lut6.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_mlab.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_mlab20_a1r1w1.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                      
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_sync20_m.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/nios_jtagsr.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                             
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/nios_nios2_smg.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                          
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/nios_rst_ctrl.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/altera_std_synchronizer_nocut.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_gdr_rst_i_synchronizers.v"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/intc_gdr_rst.sv"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/f_tile_soft_reset_ctlr_ip_v1/ftile_reset.sv"]\"  -work f_tile_soft_reset_ctlr_ip_v1"                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm1_ai_arbiter.sv"]\"  -work ctf_avmm1_ai_arbiter"                                                                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm1_req_gate.sv"]\"  -work ctf_avmm1_ai_arbiter"                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm_act_select.sv"]\"  -work ctf_avmm1_ai_arbiter"                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm1_integ_split.sv"]\"  -work ctf_avmm1_ai_arbiter"                                                                             
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/altera_std_synchronizer_nocut.v"]\"  -work ctf_avmm1_ai_arbiter"                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm2_ai_arbiter.sv"]\"  -work ctf_avmm2_ai_arbiter"                                                                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm2_req_gate.sv"]\"  -work ctf_avmm2_ai_arbiter"                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm_act_select.sv"]\"  -work ctf_avmm2_ai_arbiter"                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_gavmm_page_upd.sv"]\"  -work ctf_avmm2_ai_arbiter"                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/ctf_avmm2_integ_split.sv"]\"  -work ctf_avmm2_ai_arbiter"                                                                             
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftile_avmm_arb/altera_std_synchronizer_nocut.v"]\"  -work ctf_avmm2_ai_arbiter"                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "C:/intelfpga_pro/23.2/quartus/libraries/megafunctions/ftileb_ag_v0.sv"]\"  -work eth_f_hw_auto_tiles"                                                                                                      
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/support_logic/eth_f_hw_auto_tiles.sv"]\"  -work eth_f_hw_auto_tiles"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/ex_100G_eth_f_1000_lne26ya.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sip_lne26ya.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_hip_lne26ya.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_aib_mapping.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_cadence_gen.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_clock_mon.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_counter_based_cadence_gen.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_custom_cadence_controller.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_dp_mapping_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_dp_mapping_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_jtag_avmm.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_rcfg_arb.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                        
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reset_logic.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_rx_avst_reverse.v"]\"  -work eth_f_1000"                                                                                                                         
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_soft_cwbin_counter.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_tx_avst_reverse.v"]\"  -work eth_f_1000"                                                                                                                         
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_xcvr_debug.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                      
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_50g_adapter_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_50g_adapter_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_adapter_data_aligner_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_adapter_rptr_addgen.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                        
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_adapter_wptr_addgen.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                        
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_avalon_to_if.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_100g_rx_aligner.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_10g_25g_adapter_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_10g_25g_adapter_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_40g_bridge_otn_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_40g_bridge_otn_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_40g_bridge_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_40g_bridge_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_avst2if_pp.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                  
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_pp_block_shifter.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                         
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_pp_data_rotate_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_pp_rptr_gen_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                        
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_pp_wptr_gen.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_rptr_gen_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_rx_wptr_gen_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_tx_pp_data_rotate_3to4_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_50g_tx_pp_rptr_gen_async.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                        
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_adapter_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                      
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_adapter_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                      
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_data_mux_2to1_tx100a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_data_rotate_8to8_tx100a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                         
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_dcfifo_mlab.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_dropped_frame_count.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_if2avst.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                         
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_if_filter5.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                      
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mlab.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_preamble_filter2.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ready_gen_100g_a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ready_gen_100g_s.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reset_stretch_16a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_rptr_gen_tx100a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_stats_tx100a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                    
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_stats_txpp50s.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_wptr_gen_tx100a.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sl_adapter_rx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sl_adapter_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sl_avalon_to_if.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sl_if_to_avalon.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_accumulators.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                    
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_delay_reg.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_pointer_synchronizer.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_scfifo_mlab.v"]\"  -work eth_f_1000"                                                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_undersized_frame_csr.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/intc_mlab.v"]\"  -work eth_f_1000"                                                                                                                                     
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/intc_mlab6_a1r1w1.v"]\"  -work eth_f_1000"                                                                                                                             
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/intc_sync6_m.v"]\"  -work eth_f_1000"                                                                                                                                  
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_rx_deskew.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_tx_deskew.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_word_delay_mlab.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/bb_avmm.v"]\"  -work eth_f_1000"                                                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_alt_xcvr_arbiter.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_alt_xcvr_avmm_arb.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_alt_xcvr_resync_etile.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_avmm2.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_avmm_csr.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                        
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_base_sip_csr.v"]\"  -work eth_f_1000"                                                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_csr.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ctf_avmm1_soft_logic.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ctf_avmm2_soft_logic.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ctf_avmm_maib_if.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ft_avmm_32to8_bridge.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                            
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ptp_csr.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                         
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ptp_csr_clock_crosser.v"]\"  -work eth_f_1000"                                                                                                                   
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ptp_csr_reg.v"]\"  -work eth_f_1000"                                                                                                                             
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_rf_lf_logic.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                     
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_altera_std_synchronizer_nocut.v"]\"  -work eth_f_1000"                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_and3t0.v"]\"  -work eth_f_1000"                                                                                                                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_and3t1.v"]\"  -work eth_f_1000"                                                                                                                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_and4t0.v"]\"  -work eth_f_1000"                                                                                                                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_and4t1.v"]\"  -work eth_f_1000"                                                                                                                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_cnt6.v"]\"  -work eth_f_1000"                                                                                                                                    
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_data_sync.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_dual_port_sram.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc15h7cfbt2.v"]\"  -work eth_f_1000"                                                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc19h4e1fbt2.v"]\"  -work eth_f_1000"                                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc4h9t1.v"]\"  -work eth_f_1000"                                                                                                                                
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc5h07t1.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc5h0ft1.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc5h18t1.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc5h1bt1.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_eqc5h1ft1.v"]\"  -work eth_f_1000"                                                                                                                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_fmon8.v"]\"  -work eth_f_1000"                                                                                                                                   
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_lut6.v"]\"  -work eth_f_1000"                                                                                                                                    
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_metronome32000.v"]\"  -work eth_f_1000"                                                                                                                          
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_metronome320000.v"]\"  -work eth_f_1000"                                                                                                                         
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_multibit_sync.v"]\"  -work eth_f_1000"                                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux2w1t0s0.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux2w1t0s1.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux2w1t0s2.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux2w1t1s2.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux4w1t0s0.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux4w1t0s1.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux4w1t1s1.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_mux8w1t2s1.v"]\"  -work eth_f_1000"                                                                                                                              
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reset_synchronizer.v"]\"  -work eth_f_1000"                                                                                                                      
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reverse_2bits.v"]\"  -work eth_f_1000"                                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reverse_3bits.v"]\"  -work eth_f_1000"                                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reverse_bits.v"]\"  -work eth_f_1000"                                                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_reverse_bytes.v"]\"  -work eth_f_1000"                                                                                                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_ripple16.v"]\"  -work eth_f_1000"                                                                                                                                
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_sync1r1.v"]\"  -work eth_f_1000"                                                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_xcvr_resync_std.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_packing_rearr.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                   
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../eth_f_1000/sim/eth_f_packing_tx.sv"]\" -l altera_common_sv_packages -work eth_f_1000"                                                                                                      
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/ex_100G.v"]\"  -work ex_100G"                                                                                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_sys_pll/altera_iopll_1931/sim/eth_f_sys_pll_altera_iopll_1931_s5gg4uy.vo"]\"  -work altera_iopll_1931"                                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_sys_pll/sim/eth_f_sys_pll.v"]\"  -work eth_f_sys_pll"                                                                                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_jtag_interface.v"]\"  -work altera_jtag_dc_streaming_191"                          
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_jtag_dc_streaming.v"]\"  -work altera_jtag_dc_streaming_191"                                 
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_jtag_sld_node.v"]\"  -work altera_jtag_dc_streaming_191"                                     
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_jtag_streaming.v"]\"  -work altera_jtag_dc_streaming_191"                                    
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_clock_crosser.v"]\"  -work altera_jtag_dc_streaming_191"                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_reset_synchronizer.v"]\"  -work altera_jtag_dc_streaming_191"                                
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_std_synchronizer_nocut.v"]\"  -work altera_jtag_dc_streaming_191"                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_pipeline_base.v"]\"  -work altera_jtag_dc_streaming_191"                           
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_idle_remover.v"]\"  -work altera_jtag_dc_streaming_191"                            
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_idle_inserter.v"]\"  -work altera_jtag_dc_streaming_191"                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_dc_streaming_191/sim/altera_avalon_st_pipeline_stage.sv"]\"  -work altera_jtag_dc_streaming_191"                              
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/timing_adapter_1940/sim/eth_f_jtag_avalon_timing_adapter_1940_5ju4ddy.sv"]\"  -work timing_adapter_1940"                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_avalon_sc_fifo_1931/sim/eth_f_jtag_avalon_altera_avalon_sc_fifo_1931_fzgstwy.v"]\"  -work altera_avalon_sc_fifo_1931"         
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_avalon_st_bytes_to_packets_1922/sim/altera_avalon_st_bytes_to_packets.v"]\"  -work altera_avalon_st_bytes_to_packets_1922"    
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_avalon_st_packets_to_bytes_1922/sim/altera_avalon_st_packets_to_bytes.v"]\"  -work altera_avalon_st_packets_to_bytes_1922"    
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_avalon_packets_to_master_1922/sim/altera_avalon_packets_to_master.v"]\"  -work altera_avalon_packets_to_master_1922"          
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/channel_adapter_1921/sim/eth_f_jtag_avalon_channel_adapter_1921_5wnzrci.sv"]\"  -work channel_adapter_1921"                               
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/channel_adapter_1921/sim/eth_f_jtag_avalon_channel_adapter_1921_fkajlia.sv"]\"  -work channel_adapter_1921"                               
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_reset_controller_1921/sim/altera_reset_controller.v"]\"  -work altera_reset_controller_1921"                                  
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_reset_controller_1921/sim/altera_reset_synchronizer.v"]\"  -work altera_reset_controller_1921"                                
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/altera_jtag_avalon_master_191/sim/eth_f_jtag_avalon_altera_jtag_avalon_master_191_3zppvky.v"]\"  -work altera_jtag_avalon_master_191"
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/eth_f_jtag_avalon/sim/eth_f_jtag_avalon.v"]\"  -work eth_f_jtag_avalon"                                                                                
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/probe8/altera_in_system_sources_probes_1921/sim/altsource_probe.v"]\"  -work altera_in_system_sources_probes_1921"                                     
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/probe8/sim/probe8.v"]\"  -work probe8"                                                                                                                 
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/reset_ip/altera_s10_user_rst_clkgate_1945/sim/altera_s10_user_rst_clkgate.sv"]\"  -work altera_s10_user_rst_clkgate_1945"                                   
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/reset_ip/sim/reset_ip.v"]\"  -work reset_ip"                                                                                                           
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/systemclk_f_0/systemclk_f_250/sim/ft_avmm_32to8_bridge.sv"]\"  -work systemclk_f_250"                                                                       
  lappend design_files "vlog  $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/systemclk_f_0/systemclk_f_250/sim/systemclk_f_0_systemclk_f_250_g4ewxna.sv"]\"  -work systemclk_f_250"                                                      
  lappend design_files "vlog -v2k5 $USER_DEFINED_VERILOG_COMPILE_OPTIONS $USER_DEFINED_COMPILE_OPTIONS  \"[normalize_path "$QSYS_SIMDIR/../../hardware_test_design/common/systemclk_f_0/sim/systemclk_f_0.v"]\"  -work systemclk_f_0"                                                                                            
  return $design_files
}

proc get_elab_options {SIMULATOR_TOOL_BITNESS} {
  set ELAB_OPTIONS ""
  if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
  } else {
  }
  return $ELAB_OPTIONS
}


proc get_sim_options {SIMULATOR_TOOL_BITNESS} {
  set SIM_OPTIONS ""
  if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
  } else {
  }
  return $SIM_OPTIONS
}


proc get_env_variables {SIMULATOR_TOOL_BITNESS} {
  set ENV_VARIABLES [dict create]
  set LD_LIBRARY_PATH [dict create]
  dict set ENV_VARIABLES "LD_LIBRARY_PATH" $LD_LIBRARY_PATH
  if ![ string match "bit_64" $SIMULATOR_TOOL_BITNESS ] {
  } else {
  }
  return $ENV_VARIABLES
}


proc normalize_path {FILEPATH} {
    if {[catch { package require fileutil } err]} { 
        return $FILEPATH 
    } 
    set path [fileutil::lexnormalize [file join [pwd] $FILEPATH]]  
    if {[file pathtype $FILEPATH] eq "relative"} { 
        set path [fileutil::relative [pwd] $path] 
    } 
    return $path 
} 
