// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1 ps / 1 ps
module eth_f_hw_ip_top_tc (
    input  wire          i_clk_tx,                        //             i_tx_clk.clk,                    TX interface clock, in synchronous mode connect o_clk_pll to this clock
    input  wire          i_clk_rx,                        //             i_rx_clk.clk,                    RX interface clock, in synchronous mode connect o_clk_pll to this clock
    output wire          o_clk_pll,                       //            o_clk_pll.clk,                    System clock, this is /64 clock
    output wire          o_clk_tx_div,                    //         o_clk_tx_div.clk,                    This is /66 clock (390.625 MHz)
    output wire          o_clk_rec_div64,                 //      o_clk_rec_div64.clk,                    This is /64 recovered clock (402.83 MHz)
    output wire          o_clk_rec_div,                   //        o_clk_rec_div.clk,                    This is /66 recovered clock (390.625 MHz)
    input  wire          i_tx_rst_n,                      //           i_tx_rst_n.reset,                  Resets the TX digital path (MAC, PCS)
    input  wire          i_rx_rst_n,                      //           i_rx_rst_n.reset,                  Resets the RX digital path (MAC, PCS)
    input  wire          i_rst_n,                         //              i_rst_n.reset,                  Resets TX/RX datapaths (MAC, PCS) and TX/RX transceiver & AIB
    output wire          o_rst_ack_n,                     //          o_rst_ack_n.reset,                  Acknowledge signal for i_rst_n
    output wire          o_tx_rst_ack_n,                  //       o_tx_rst_ack_n.reset,                  Acknowledge signal for i_tx_rst_n
    output wire          o_rx_rst_ack_n,                  //       o_rx_rst_ack_n.reset,                  Acknowledge signal for i_rx_rst_n
    input  wire          i_reconfig_clk,                  //       i_reconfig_clk.clk,                    XCVR reconfiguration clock
    input  wire          i_reconfig_reset,                //     i_reconfig_reset.reset,                  XCVR reconfig reset
    output wire          o_cdr_lock,                      //           o_cdr_lock.o_cdr_lock,             CDR lock
    output wire          o_tx_pll_locked,                 //      o_tx_pll_locked.o_tx_pll_locked,        TX PLL Locked
    output wire          o_tx_lanes_stable,               //    o_tx_lanes_stable.o_tx_lanes_stable,      Asserted when TX MAC is ready to send data
    output wire          o_rx_pcs_ready,                  //       o_rx_pcs_ready.o_rx_pcs_ready,         Asserted when RX PCS is ready to receive data   .i_clk_rx                         (i_clk_rx),
    input  wire [16:0]   i_reconfig_eth_addr,             //   reconfig_eth_slave.address,                Address for Ethernet CSRs
    input  wire [3:0]    i_reconfig_eth_byteenable,       //                     .byteenable,             Byte enable for read/write to Ethernet CSRs
    output wire          o_reconfig_eth_readdata_valid,   //                     .readdatavalid,          Read data from Ethernet CSRs is valid
    input  wire          i_reconfig_eth_read,             //                     .read,                   Read command for Ethernet CSRs
    input  wire          i_reconfig_eth_write,            //                     .write,                  Write command for Ethernet CSRs
    output wire [31:0]   o_reconfig_eth_readdata,         //                     .readdata,               Read data from reads to Ethernet CSRs
    input  wire [31:0]   i_reconfig_eth_writedata,        //                     .writedata,              Data for writes to Ethernet CSRs
    output wire          o_reconfig_eth_waitrequest,      //                     .waitrequest,            AVMM stall signal for operation on Ethernet CSRs    .i_reconfig_eth_addr              (i_reconfig_eth_addr           ),
    input  wire [18-1:0]   i_reconfig_xcvr0_addr,
    input  wire [1-1:0]    i_reconfig_xcvr0_read,
    input  wire [1-1:0]    i_reconfig_xcvr0_write,
    input  wire [32-1:0]   i_reconfig_xcvr0_writedata,
    input  wire [4-1:0]    i_reconfig_xcvr0_byteenable,
    output wire [32-1:0]   o_reconfig_xcvr0_readdata,
    output wire [1-1:0]    o_reconfig_xcvr0_readdata_valid,
    output wire [1-1:0]    o_reconfig_xcvr0_waitrequest,
    input  wire [18-1:0]   i_reconfig_xcvr1_addr,
    input  wire [1-1:0]    i_reconfig_xcvr1_read,
    input  wire [1-1:0]    i_reconfig_xcvr1_write,
    input  wire [32-1:0]   i_reconfig_xcvr1_writedata,
    input  wire [4-1:0]    i_reconfig_xcvr1_byteenable,
    output wire [32-1:0]   o_reconfig_xcvr1_readdata,
    output wire [1-1:0]    o_reconfig_xcvr1_readdata_valid,
    output wire [1-1:0]    o_reconfig_xcvr1_waitrequest,
    input  wire [18-1:0]   i_reconfig_xcvr2_addr,
    input  wire [1-1:0]    i_reconfig_xcvr2_read,
    input  wire [1-1:0]    i_reconfig_xcvr2_write,
    input  wire [32-1:0]   i_reconfig_xcvr2_writedata,
    input  wire [4-1:0]    i_reconfig_xcvr2_byteenable,
    output wire [32-1:0]   o_reconfig_xcvr2_readdata,
    output wire [1-1:0]    o_reconfig_xcvr2_readdata_valid,
    output wire [1-1:0]    o_reconfig_xcvr2_waitrequest,
    input  wire [18-1:0]   i_reconfig_xcvr3_addr,
    input  wire [1-1:0]    i_reconfig_xcvr3_read,
    input  wire [1-1:0]    i_reconfig_xcvr3_write,
    input  wire [32-1:0]   i_reconfig_xcvr3_writedata,
    input  wire [4-1:0]    i_reconfig_xcvr3_byteenable,
    output wire [32-1:0]   o_reconfig_xcvr3_readdata,
    output wire [1-1:0]    o_reconfig_xcvr3_readdata_valid,
    output wire [1-1:0]    o_reconfig_xcvr3_waitrequest,
    output wire          o_rx_block_lock,                 //         status_ports.o_rx_block_lock,        Asserted when 66b block alignment is finished on all PCS lanes
    output wire          o_rx_am_lock,                    //                     .o_rx_am_lock,           Asserted when RX PCS has found detected alignment markers and deskewed PCS lanes
    output wire          o_local_fault_status,            //                     .o_local_fault_status,   The RX PCS has detected a problem that prevents it from being able to receive data
    output wire          o_remote_fault_status,           //                     .o_remote_fault_status,  The remote link partner has sent remote fault ordered sets indicating that it is unable to receive data    .o_rx_hi_ber                      (o_rx_hi_ber           ),        
    output wire          o_rx_hi_ber,                     //                     .o_rx_hi_ber,            Asserted when RX PCS detected high BER; in AN/LT mode, this will trigger re-negotiation
    output wire          o_rx_pcs_fully_aligned,          //                     .o_rx_pcs_fully_aligned, PCS is fully aligned
   // input wire                             i_clk_sys,
   // input wire                             i_clk_ref,
    input wire                             i_refclk2pll,
    input wire  [4-1:0]            i_rx_serial,
    input wire  [4-1:0]            i_rx_serial_n,
    output wire [4-1:0]            o_tx_serial,
    output wire [4-1:0]            o_tx_serial_n,
    input  wire                            i_tx_pause,
    input  wire [7:0]                      i_tx_pfc,
    output wire [7:0]                      o_rx_pfc,
    output wire                            o_rx_pause,
    input wire  [64*8-1:0]       i_tx_data,         
    input wire                             i_tx_valid,        
    input wire                             i_tx_startofpacket,
    input wire                             i_tx_endofpacket,  
    input wire                             i_tx_error,        
    output wire  		           o_tx_ready,        
    input wire      [6-1:0]      i_tx_empty,        
    input wire                             i_tx_skip_crc,     
    output wire    [64*8-1:0]    o_rx_data,         
    output wire                            o_rx_valid,        
    output wire                            o_rx_startofpacket,
    output wire                            o_rx_endofpacket,  
    output wire    [6-1:0]       o_rx_empty,        
    output wire    [6-1:0]                 o_rx_error,        
    output wire                            o_rxstatus_valid,  
    output wire    [39:0]                  o_rxstatus_data,   
    input wire                                  i_stats_snapshot
);


//---------------------------------------------------------------
  systemclk_f_0 sys_pll(
     .out_systempll_clk_0(i_clk_sys),               // out_systempll_clk_0.clk
     .in_refclk_fgt_0(i_refclk2pll),                // refclk_fgt.in_refclk_fgt_0
     .out_refclk_fgt_0(i_clk_ref)                // out_refclk_fgt_0.clk
);

//---------------------------------------------------------------
//---------------------------------------------------------------
ex_100G dut (
    .i_clk_rx                         (i_clk_rx),
    .i_clk_tx                         (i_clk_tx),
    .o_clk_pll                        (o_clk_pll), 

    .o_clk_tx_div                     (o_clk_tx_div                  ), 
    .o_clk_rec_div64                  (o_clk_rec_div64), 
    .o_clk_rec_div                    (o_clk_rec_div                 ), 
    .i_rx_rst_n                       (i_rx_rst_n),
    .i_tx_rst_n                       (i_tx_rst_n),
    .i_rst_n                          (i_rst_n                       ),
    .o_rst_ack_n                      (o_rst_ack_n                   ),
    .o_rx_rst_ack_n                   (o_rx_rst_ack_n                ),
    .o_tx_rst_ack_n                   (o_tx_rst_ack_n                ),
    .i_reconfig_clk                   (i_reconfig_clk),
    .i_reconfig_reset                 (i_reconfig_reset),
    .o_cdr_lock                       (o_cdr_lock                    ), 
    .o_tx_pll_locked                  (o_tx_pll_locked               ),  
    .o_tx_lanes_stable                (o_tx_lanes_stable             ), 
    .o_rx_pcs_ready                   (o_rx_pcs_ready                ),
    .i_reconfig_eth_addr              (i_reconfig_eth_addr[15:2]     ),
    .i_reconfig_eth_byteenable        (i_reconfig_eth_byteenable     ),
    .o_reconfig_eth_readdata_valid    (o_reconfig_eth_readdata_valid ),
    .i_reconfig_eth_read              (i_reconfig_eth_read),
    .i_reconfig_eth_write             (i_reconfig_eth_write),
    .o_reconfig_eth_readdata          (o_reconfig_eth_readdata       ),
    .i_reconfig_eth_writedata         (i_reconfig_eth_writedata),
    .o_reconfig_eth_waitrequest       (o_reconfig_eth_waitrequest),
    .i_reconfig_xcvr0_addr            (i_reconfig_xcvr0_addr),
    .i_reconfig_xcvr0_read            (i_reconfig_xcvr0_read),
    .i_reconfig_xcvr0_write           (i_reconfig_xcvr0_write),
    .i_reconfig_xcvr0_writedata       (i_reconfig_xcvr0_writedata),
    .i_reconfig_xcvr0_byteenable      (i_reconfig_xcvr0_byteenable),
    .o_reconfig_xcvr0_readdata        (o_reconfig_xcvr0_readdata),
    .o_reconfig_xcvr0_readdata_valid  (o_reconfig_xcvr0_readdata_valid),
    .o_reconfig_xcvr0_waitrequest     (o_reconfig_xcvr0_waitrequest),
    .i_reconfig_xcvr1_addr            (i_reconfig_xcvr1_addr),
    .i_reconfig_xcvr1_read            (i_reconfig_xcvr1_read),
    .i_reconfig_xcvr1_write           (i_reconfig_xcvr1_write),
    .i_reconfig_xcvr1_writedata       (i_reconfig_xcvr1_writedata),
    .i_reconfig_xcvr1_byteenable      (i_reconfig_xcvr1_byteenable),
    .o_reconfig_xcvr1_readdata        (o_reconfig_xcvr1_readdata),
    .o_reconfig_xcvr1_readdata_valid  (o_reconfig_xcvr1_readdata_valid),
    .o_reconfig_xcvr1_waitrequest     (o_reconfig_xcvr1_waitrequest),
    .i_reconfig_xcvr2_addr            (i_reconfig_xcvr2_addr),
    .i_reconfig_xcvr2_read            (i_reconfig_xcvr2_read),
    .i_reconfig_xcvr2_write           (i_reconfig_xcvr2_write),
    .i_reconfig_xcvr2_writedata       (i_reconfig_xcvr2_writedata),
    .i_reconfig_xcvr2_byteenable      (i_reconfig_xcvr2_byteenable),
    .o_reconfig_xcvr2_readdata        (o_reconfig_xcvr2_readdata),
    .o_reconfig_xcvr2_readdata_valid  (o_reconfig_xcvr2_readdata_valid),
    .o_reconfig_xcvr2_waitrequest     (o_reconfig_xcvr2_waitrequest),
    .i_reconfig_xcvr3_addr            (i_reconfig_xcvr3_addr),
    .i_reconfig_xcvr3_read            (i_reconfig_xcvr3_read),
    .i_reconfig_xcvr3_write           (i_reconfig_xcvr3_write),
    .i_reconfig_xcvr3_writedata       (i_reconfig_xcvr3_writedata),
    .i_reconfig_xcvr3_byteenable      (i_reconfig_xcvr3_byteenable),
    .o_reconfig_xcvr3_readdata        (o_reconfig_xcvr3_readdata),
    .o_reconfig_xcvr3_readdata_valid  (o_reconfig_xcvr3_readdata_valid),
    .o_reconfig_xcvr3_waitrequest     (o_reconfig_xcvr3_waitrequest),
    .o_rx_block_lock                  (o_rx_block_lock       ),        
    .o_rx_am_lock                     (o_rx_am_lock          ),        
    .o_local_fault_status             (o_local_fault_status  ),   
    .o_remote_fault_status            (o_remote_fault_status ),      
    .o_rx_hi_ber                      (o_rx_hi_ber           ),        
    .o_rx_pcs_fully_aligned           (o_rx_pcs_fully_aligned),
    .i_clk_sys                        (i_clk_sys),  //Need to connect with sys_pll IP
    .i_clk_ref                        (i_clk_ref),
    .i_rx_serial                      (i_rx_serial  ),
    .i_rx_serial_n                    (i_rx_serial_n), 
    .o_tx_serial                      (o_tx_serial  ), 
    .o_tx_serial_n                    (o_tx_serial_n), 
    .i_tx_pause                       (i_tx_pause),
    .i_tx_pfc                         (i_tx_pfc),
    .o_rx_pfc                         (o_rx_pfc),
    .o_rx_pause                       (o_rx_pause),
    .i_tx_data                        (i_tx_data),
    .i_tx_valid                       (i_tx_valid),
    .i_tx_startofpacket               (i_tx_startofpacket), 
    .i_tx_endofpacket                 (i_tx_endofpacket),
    .i_tx_error                       (i_tx_error                    ),
    .o_tx_ready                       (o_tx_ready),
    .i_tx_empty                       (i_tx_empty),
    .i_tx_skip_crc                    (i_tx_skip_crc), 
    .o_rx_data                        (o_rx_data),
    .o_rx_valid                       (o_rx_valid),
    .o_rx_startofpacket               (o_rx_startofpacket),
    .o_rx_endofpacket                 (o_rx_endofpacket),
    .o_rx_empty                       (o_rx_empty),
    .o_rx_error                       (o_rx_error),
    .o_rxstatus_valid                 (o_rxstatus_valid),
    .o_rxstatus_data                  (o_rxstatus_data),
    .i_stats_snapshot                 (i_stats_snapshot)
);



//---------------------------------------------------------------
endmodule


