// (C) 2001-2023 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.




module mem_ram #(parameter DW = 8, DEPTH = 16)

   (
     
    input  var logic clk,
    input  var logic wren,
    input  var logic [DW-1:0] wdata,
    input  var logic [$clog2(DEPTH)-1:0] waddr,

    input  var logic rden,
    input  var logic [$clog2(DEPTH)-1:0] raddr,
    
    output var logic [DW-1:0] rdata

     );

    logic [DEPTH-1:0] [DW-1:0] mem;


    always_ff @(posedge clk) begin
	if (wren)
	    mem[waddr] <= wdata;	
    end

    always_ff @(posedge clk) begin
	if (rden)
	    rdata <= mem[raddr];
    end


endmodule
