module pcie_ftile_mcdma (
		output wire         app_clk,                //            app_clk.clk,               Check User Guide for details
		output wire         app_rst_n,              //  app_nreset_status.reset_n,           Check User Guide for details
		input  wire         d2hdm_waitrequest_i,    //    p0_d2hdm_master.waitrequest,       Check User Guide for details
		output wire         d2hdm_read_o,           //                   .read,              Check User Guide for details
		output wire [63:0]  d2hdm_address_o,        //                   .address,           Check User Guide for details
		output wire [4:0]   d2hdm_burstcount_o,     //                   .burstcount,        Check User Guide for details
		output wire [31:0]  d2hdm_byteenable_o,     //                   .byteenable,        Check User Guide for details
		input  wire         d2hdm_readdatavalid_i,  //                   .readdatavalid,     Check User Guide for details
		input  wire [255:0] d2hdm_readdata_i,       //                   .readdata,          Check User Guide for details
		input  wire [1:0]   d2hdm_response_i,       //                   .response,          Check User Guide for details
		input  wire         h2ddm_waitrequest_i,    //    p0_h2ddm_master.waitrequest,       Check User Guide for details
		output wire         h2ddm_write_o,          //                   .write,             Check User Guide for details
		output wire [63:0]  h2ddm_address_o,        //                   .address,           Check User Guide for details
		output wire [4:0]   h2ddm_burstcount_o,     //                   .burstcount,        Check User Guide for details
		output wire [31:0]  h2ddm_byteenable_o,     //                   .byteenable,        Check User Guide for details
		output wire [255:0] h2ddm_writedata_o,      //                   .writedata,         Check User Guide for details
		input  wire         bam_waitrequest_i,      //      p0_bam_master.waitrequest,       Check User Guide for details
		output wire [29:0]  bam_address_o,          //                   .address,           Check User Guide for details
		output wire [31:0]  bam_byteenable_o,       //                   .byteenable,        Check User Guide for details
		output wire         bam_read_o,             //                   .read,              Check User Guide for details
		input  wire [255:0] bam_readdata_i,         //                   .readdata,          Check User Guide for details
		input  wire         bam_readdatavalid_i,    //                   .readdatavalid,     Check User Guide for details
		output wire         bam_write_o,            //                   .write,             Check User Guide for details
		output wire [255:0] bam_writedata_o,        //                   .writedata,         Check User Guide for details
		output wire [4:0]   bam_burstcount_o,       //                   .burstcount,        Check User Guide for details
		output wire [2:0]   usr_hip_tl_cfg_func_o,  //   p0_usr_config_tl.tl_cfg_func,       Check User Guide for details
		output wire [4:0]   usr_hip_tl_cfg_add_o,   //                   .tl_cfg_add,        Check User Guide for details
		output wire [15:0]  usr_hip_tl_cfg_ctl_o,   //                   .tl_cfg_ctl,        Check User Guide for details
		output wire         p0_link_up_o,           //      p0_hip_status.link_up,           Check User Guide for details
		output wire         p0_dl_up_o,             //                   .dl_up,             Check User Guide for details
		output wire         p0_surprise_down_err_o, //                   .surprise_down_err, Check User Guide for details
		output wire [5:0]   p0_ltssm_state_o,       //                   .ltssmstate,        Check User Guide for details
		input  wire         refclk0,                //            refclk0.clk,               Refclk for SystemPLL and PCIe PHY. Connect a refclk output "out_refclk_fgt_<i>i</i>" from the "F-Tile Reference and SystemPLL Clocks" IP to this port
		input  wire         refclk1,                //            refclk1.clk,               Refclk for PCIe1 PHY in 2x8 topology. Drive this input with the same clock for refclk0 input port, if:<br>- Your design does not need a separate refclk, or<br>- You are not using 2x8 topology
		input  wire         pcie_systempll_clk,     // pcie_systempll_clk.clk,               System PLL for PCIe IP. Connect "out_systempll_clk_0" from the "F-Tile Reference and SystemPLL Clocks" IP to this port.
		input  wire         ninit_done,             //         ninit_done.reset,             Its a Init_done signal should be connected to Reset release IP
		input  wire         pin_perst_n,            //          pin_perst.reset_n,           Check User Guide for details
		input  wire         rx_n_in0,               //         hip_serial.rx_n_in0,          Check User Guide for details
		input  wire         rx_n_in1,               //                   .rx_n_in1,          Check User Guide for details
		input  wire         rx_n_in2,               //                   .rx_n_in2,          Check User Guide for details
		input  wire         rx_n_in3,               //                   .rx_n_in3,          Check User Guide for details
		input  wire         rx_n_in4,               //                   .rx_n_in4,          Check User Guide for details
		input  wire         rx_n_in5,               //                   .rx_n_in5,          Check User Guide for details
		input  wire         rx_n_in6,               //                   .rx_n_in6,          Check User Guide for details
		input  wire         rx_n_in7,               //                   .rx_n_in7,          Check User Guide for details
		input  wire         rx_p_in0,               //                   .rx_p_in0,          Check User Guide for details
		input  wire         rx_p_in1,               //                   .rx_p_in1,          Check User Guide for details
		input  wire         rx_p_in2,               //                   .rx_p_in2,          Check User Guide for details
		input  wire         rx_p_in3,               //                   .rx_p_in3,          Check User Guide for details
		input  wire         rx_p_in4,               //                   .rx_p_in4,          Check User Guide for details
		input  wire         rx_p_in5,               //                   .rx_p_in5,          Check User Guide for details
		input  wire         rx_p_in6,               //                   .rx_p_in6,          Check User Guide for details
		input  wire         rx_p_in7,               //                   .rx_p_in7,          Check User Guide for details
		output wire         tx_n_out0,              //                   .tx_n_out0,         Check User Guide for details
		output wire         tx_n_out1,              //                   .tx_n_out1,         Check User Guide for details
		output wire         tx_n_out2,              //                   .tx_n_out2,         Check User Guide for details
		output wire         tx_n_out3,              //                   .tx_n_out3,         Check User Guide for details
		output wire         tx_n_out4,              //                   .tx_n_out4,         Check User Guide for details
		output wire         tx_n_out5,              //                   .tx_n_out5,         Check User Guide for details
		output wire         tx_n_out6,              //                   .tx_n_out6,         Check User Guide for details
		output wire         tx_n_out7,              //                   .tx_n_out7,         Check User Guide for details
		output wire         tx_p_out0,              //                   .tx_p_out0,         Check User Guide for details
		output wire         tx_p_out1,              //                   .tx_p_out1,         Check User Guide for details
		output wire         tx_p_out2,              //                   .tx_p_out2,         Check User Guide for details
		output wire         tx_p_out3,              //                   .tx_p_out3,         Check User Guide for details
		output wire         tx_p_out4,              //                   .tx_p_out4,         Check User Guide for details
		output wire         tx_p_out5,              //                   .tx_p_out5,         Check User Guide for details
		output wire         tx_p_out6,              //                   .tx_p_out6,         Check User Guide for details
		output wire         tx_p_out7               //                   .tx_p_out7,         Check User Guide for details
	);
endmodule

