
`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_QSFP28
//`define ENABLE_FMCP
`define ENABLE_HPS
//`define ENABLE_HDMI
//`define ENABLE_PCIE

module ghrd_agilex_top(

      ///////// CLOCK /////////
      input              CLK_100_B3A_p,
      input              CLK_100_p,
      input              CLK_148M5_p,
      input              CLK_50_B2D_p,
      input              CLK_50_B2E_p,
      input              CLK_50_B3A_p,
      input              CLK_50_B3C_p,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON, //BUTTON is Low-Active

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [16: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output             DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output             DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output             DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_EVENT_n,
      inout              DDR4A_SCL,
      inout              DDR4A_SDA,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [16: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output             DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output             DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output             DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

`ifdef ENABLE_HDMI
      ///////// HDMI /////////
      output   [ 3: 0]   HDMI_TX_D_p,
      output   [ 3: 0]   HDMI_TX_D_n,
      input              HDMI_REFCLK_100_p,
      input              HDMI_REFCLK_148M5_p,
      output             DVI_TX_5V,
      input              DVI_TX_CEC_IN_n,
      output             DVI_TX_CEC_OUT_n,
      input              DVI_TX_HPD_n,
      inout              DVI_TX_SCL,
      inout              DVI_TX_SDA,
      inout              HDMI_TX_SCL,
      inout              HDMI_TX_SDA,
`endif /*ENABLE_HDMI*/

      ///////// SI5340A0 /////////
      inout              SI5340A0_I2C_SCL,
      inout              SI5340A0_I2C_SDA,
      output             SI5340A0_OE_n,
      output             SI5340A0_RST_n,

      ///////// SI5340A1 /////////
      inout              SI5340A1_I2C_SCL,
      inout              SI5340A1_I2C_SDA,
      output             SI5340A1_OE_n,
      output             SI5340A1_RST_n,

      ///////// GPIO /////////
      input    [ 1: 0]   GPIO_CLK,
      inout    [ 3: 0]   GPIO_P,

`ifdef ENABLE_FMCP
      ///////// FMCP /////////
      inout              FMCP_CLK2_BIDIR_p,
      inout              FMCP_CLK2_BIDIR_n,
      inout              FMCP_CLK3_BIDIR_p,
      inout              FMCP_CLK3_BIDIR_n,
      output   [15: 0]   FMCP_DP_C2M_p,
      output   [15: 0]   FMCP_DP_C2M_n,
      input    [15: 0]   FMCP_DP_M2C_p,
      input    [15: 0]   FMCP_DP_M2C_n,
      inout    [23: 0]   FMCP_HA_p,
      inout    [23: 0]   FMCP_HA_n,
      inout    [21: 0]   FMCP_HB_p,
      inout    [21: 0]   FMCP_HB_n,
      inout    [33: 0]   FMCP_LA_p,
      inout    [33: 0]   FMCP_LA_n,
      input    [ 1: 0]   FMCP_CLK_M2C_p,
      input    [ 1: 0]   FMCP_GBTCLK_M2C_p,
      output             FMCP_REFCLK_C2M_p,
      input              FMCP_REFCLK_M2C_p,
      input    [ 3: 0]   FMCP_REFCLK_p,
      inout    [ 1: 0]   FMCP_GA,
      input              FMCP_RES0,
      inout              FMCP_RES1,
      inout              FMCP_SCL,
      inout              FMCP_SDA,
      output             FMCP_SYNC_C2M_p,
      input              FMCP_SYNC_M2C_p,
`endif /*ENABLE_FMCP*/

`ifdef ENABLE_PCIE
      ///////// PCIE /////////
      inout              PCIE_SMBCLK,
      inout              PCIE_SMBDAT,
      output   [ 7: 0]   PCIE_TX_p,
      output   [ 7: 0]   PCIE_TX_n,
      input    [ 7: 0]   PCIE_RX_p,
      input    [ 7: 0]   PCIE_RX_n,
      input              PCIE_REFCLK_p,
      input              PCIE_PERST_n,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_QSFP28
      ///////// QSFP28 /////////
      output   [ 3: 0]   QSFP28_TX_p,
      output   [ 3: 0]   QSFP28_TX_n,
      input    [ 3: 0]   QSFP28_RX_p,
      input    [ 3: 0]   QSFP28_RX_n,
      input    [ 1: 0]   QSFP28_REFCLK_p,
      input              QSFP28_INTERRUPT_n,
      output             QSFP28_LP_MODE,
      input              QSFP28_MOD_PRS_n,
      output             QSFP28_MOD_SEL_n,
      output             QSFP28_RST_n,
      inout              QSFP28_SCL,
      inout              QSFP28_SDA,
`endif /*ENABLE_QSFP28*/

      ///////// EXP /////////
      input              EXP_EN,

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      input              HPS_JTAG_TCK,
      input              HPS_JTAG_TDI,
      output             HPS_JTAG_TDO,
      input              HPS_JTAG_TMS,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
`endif /*ENABLE_HPS*/

      ///////// INFO /////////
      output             INFO_SPI_SCLK,
      input              INFO_SPI_MISO,
      output             INFO_SPI_MOSI,
      output             INFO_SPI_CS_n

);

assign SI5340A0_OE_n = 1'b0;
assign SI5340A0_RST_n = 1'b1;
assign SI5340A1_OE_n = 1'b0;
assign SI5340A1_RST_n = 1'b1;

wire         system_clk_100;
wire         system_clk_100_internal;
wire         ninit_done;
wire         fpga_reset_n_debounced_wire;
reg          fpga_reset_n_debounced;
wire         src_reset_n;
wire         system_reset_n;
wire         h2f_reset;
wire         niosv_issp_reset;


assign system_reset_n = fpga_reset_n_debounced & src_reset_n & ~h2f_reset & ~ninit_done;

assign system_clk_100   = CLK_100_B3A_p;

assign system_clk_100_internal  = system_clk_100;


wire [2-1:0]  fpga_led_pio;
wire [2-1:0]  fpga_dipsw_pio;
wire [2-1:0]  fpga_button_pio;
wire [1-1:0]  fpga_reset_n;
assign LED = fpga_led_pio;
assign fpga_dipsw_pio = SW;
assign fpga_button_pio = BUTTON;
assign fpga_reset_n = CPU_RESET_n;


wire [2-1:0]     fpga_debounced_buttons;
wire [2-2:0]     fpga_led_internal;
wire           heartbeat_led;
reg  [24:0]    heartbeat_count;
assign fpga_led_pio = {heartbeat_led,fpga_led_internal[0]};
assign heartbeat_led = ~heartbeat_count[24];



wire [31:0]    f2h_irq1_irq;


wire [43:0]    stm_hw_events;

assign stm_hw_events    = {{20{1'b0}}, heartbeat_led, fpga_led_internal, fpga_dipsw_pio, fpga_debounced_buttons};





assign f2h_irq1_irq    = {32'b0};

//Temporary disable src_reset_n
assign src_reset_n = 1'b1;

// Qsys Top module
    qsys_top soc_inst (
//        .wd_reset_reset_n                          (_connected_to_wd_reset_reset_n_),                          //  output,   width = 1,                       wd_reset.reset_n
        .agilex_hps_f2h_stm_hw_events_stm_hwevents (stm_hw_events), //   input,  width = 44,   agilex_hps_f2h_stm_hw_events.stm_hwevents
        .agilex_hps_h2f_cs_ntrst                   (1'b1),                   //   input,   width = 1,              agilex_hps_h2f_cs.ntrst
        .agilex_hps_h2f_cs_tck                     (1'b1),                     //   input,   width = 1,                               .tck
        .agilex_hps_h2f_cs_tdi                     (1'b1),                     //   input,   width = 1,                               .tdi
        .agilex_hps_h2f_cs_tdo                     (),                     //  output,   width = 1,                               .tdo
        .agilex_hps_h2f_cs_tdoen                   (),                   //  output,   width = 1,                               .tdoen
        .agilex_hps_h2f_cs_tms                     (1'b1),                     //   input,   width = 1,                               .tms
        .hps_io_EMAC0_TX_CLK                       (HPS_ENET_TX_CLK),                       //  output,   width = 1,                         hps_io.EMAC0_TX_CLK
        .hps_io_EMAC0_TXD0                         (HPS_ENET_TX_DATA[0]),                         //  output,   width = 1,                               .EMAC0_TXD0
        .hps_io_EMAC0_TXD1                         (HPS_ENET_TX_DATA[1]),                         //  output,   width = 1,                               .EMAC0_TXD1
        .hps_io_EMAC0_TXD2                         (HPS_ENET_TX_DATA[2]),                         //  output,   width = 1,                               .EMAC0_TXD2
        .hps_io_EMAC0_TXD3                         (HPS_ENET_TX_DATA[3]),                         //  output,   width = 1,                               .EMAC0_TXD3
        .hps_io_EMAC0_RX_CTL                       (HPS_ENET_RX_CTL),                       //   input,   width = 1,                               .EMAC0_RX_CTL
        .hps_io_EMAC0_TX_CTL                       (HPS_ENET_TX_CTL),                       //  output,   width = 1,                               .EMAC0_TX_CTL
        .hps_io_EMAC0_RX_CLK                       (HPS_ENET_RX_CLK),                       //   input,   width = 1,                               .EMAC0_RX_CLK
        .hps_io_EMAC0_RXD0                         (HPS_ENET_RX_DATA[0]),                         //   input,   width = 1,                               .EMAC0_RXD0
        .hps_io_EMAC0_RXD1                         (HPS_ENET_RX_DATA[1]),                         //   input,   width = 1,                               .EMAC0_RXD1
        .hps_io_EMAC0_RXD2                         (HPS_ENET_RX_DATA[2]),                         //   input,   width = 1,                               .EMAC0_RXD2
        .hps_io_EMAC0_RXD3                         (HPS_ENET_RX_DATA[3]),                         //   input,   width = 1,                               .EMAC0_RXD3
        .hps_io_EMAC0_MDIO                         (HPS_ENET_MDIO),                         //   inout,   width = 1,                               .EMAC0_MDIO
        .hps_io_EMAC0_MDC                          (HPS_ENET_MDC),                          //  output,   width = 1,                               .EMAC0_MDC
        .hps_io_SDMMC_CMD                          (HPS_SD_CMD),                          //   inout,   width = 1,                               .SDMMC_CMD
        .hps_io_SDMMC_D0                           (HPS_SD_DATA[0]),                           //   inout,   width = 1,                               .SDMMC_D0
        .hps_io_SDMMC_D1                           (HPS_SD_DATA[1]),                           //   inout,   width = 1,                               .SDMMC_D1
        .hps_io_SDMMC_D2                           (HPS_SD_DATA[2]),                           //   inout,   width = 1,                               .SDMMC_D2
        .hps_io_SDMMC_D3                           (HPS_SD_DATA[3]),                           //   inout,   width = 1,                               .SDMMC_D3
        .hps_io_SDMMC_CCLK                         (HPS_SD_CLK),                         //  output,   width = 1,                               .SDMMC_CCLK
        .hps_io_UART0_RX                           (HPS_UART_RX),                           //   input,   width = 1,                               .UART0_RX
        .hps_io_UART0_TX                           (HPS_UART_TX),                           //  output,   width = 1,                               .UART0_TX
        .hps_io_gpio1_io0                          (HPS_LED),                          //   inout,   width = 1,                               .gpio1_io0
        .hps_io_gpio1_io1                          (HPS_KEY),                          //   inout,   width = 1,                               .gpio1_io1
        .hps_io_hps_osc_clk                        (HPS_OSC_CLK),                        //   input,   width = 1,                               .hps_osc_clk
        .hps_io_jtag_tck                           (HPS_JTAG_TCK),                           //   input,   width = 1,                               .jtag_tck
        .hps_io_jtag_tms                           (HPS_JTAG_TMS),                           //   input,   width = 1,                               .jtag_tms
        .hps_io_jtag_tdo                           (HPS_JTAG_TDO),                           //  output,   width = 1,                               .jtag_tdo
        .hps_io_jtag_tdi                           (HPS_JTAG_TDI),                           //   input,   width = 1,                               .jtag_tdi
        .h2f_reset_reset                           (h2f_reset),                           //  output,   width = 1,                      h2f_reset.reset
        .f2h_irq1_irq                              (f2h_irq1_irq),                              //   input,  width = 32,                       f2h_irq1.irq
        .clk_100_clk                               (system_clk_100_internal),                               //   input,   width = 1,                        clk_100.clk
		  .emif_hps_pll_ref_clk_clk                  (DDR4A_REFCLK_p),                  //   input,   width = 1,           emif_hps_pll_ref_clk.clk
        .emif_hps_oct_oct_rzqin                    (DDR4A_RZQ),                    //   input,   width = 1,                   emif_hps_oct.oct_rzqin
        .emif_hps_mem_mem_ck                       (DDR4A_CK),                       //  output,   width = 1,                   emif_hps_mem.mem_ck
        .emif_hps_mem_mem_ck_n                     (DDR4A_CK_n),                     //  output,   width = 1,                               .mem_ck_n
        .emif_hps_mem_mem_a                        (DDR4A_A),                        //  output,  width = 17,                               .mem_a
        .emif_hps_mem_mem_act_n                    (DDR4A_ACT_n),                    //  output,   width = 1,                               .mem_act_n
        .emif_hps_mem_mem_ba                       (DDR4A_BA),                       //  output,   width = 2,                               .mem_ba
        .emif_hps_mem_mem_bg                       (DDR4A_BG),                       //  output,   width = 2,                               .mem_bg
        .emif_hps_mem_mem_cke                      (DDR4A_CKE),                      //  output,   width = 1,                               .mem_cke
        .emif_hps_mem_mem_cs_n                     (DDR4A_CS_n),                     //  output,   width = 1,                               .mem_cs_n
        .emif_hps_mem_mem_odt                      (DDR4A_ODT),                      //  output,   width = 1,                               .mem_odt
        .emif_hps_mem_mem_reset_n                  (DDR4A_RESET_n),                  //  output,   width = 1,                               .mem_reset_n
        .emif_hps_mem_mem_par                      (DDR4A_PAR),                      //  output,   width = 1,                               .mem_par
        .emif_hps_mem_mem_alert_n                  (DDR4A_ALERT_n),                  //   input,   width = 1,                               .mem_alert_n
        .emif_hps_mem_mem_dqs                      (DDR4A_DQS),                      //   inout,   width = 9,                               .mem_dqs
        .emif_hps_mem_mem_dqs_n                    (DDR4A_DQS_n),                    //   inout,   width = 9,                               .mem_dqs_n
        .emif_hps_mem_mem_dq                       (DDR4A_DQ),                       //   inout,  width = 72,                               .mem_dq
        .emif_hps_mem_mem_dbi_n                    (DDR4A_DBI_n),                    //   inout,   width = 9,                               .mem_dbi_n
        .niosv_issp_reset_in_reset                 (niosv_issp_reset),                 //   input,   width = 1,            niosv_issp_reset_in.reset
        .niosv_issp_reset_out_source               (niosv_issp_reset),               //  output,   width = 1,           niosv_issp_reset_out.source
        .button_pio_external_connection_export     (fpga_debounced_buttons),     //   input,   width = 2, button_pio_external_connection.export
        .dipsw_pio_external_connection_export      (fpga_dipsw_pio),      //   input,   width = 2,  dipsw_pio_external_connection.export
        .led_pio_external_connection_in_port       (fpga_led_internal),       //   input,   width = 2,    led_pio_external_connection.in_port
        .led_pio_external_connection_out_port      (fpga_led_internal),      //  output,   width = 2,                               .out_port
        .reset_reset_n                             (system_reset_n),                             //   input,   width = 1,                          reset.reset_n
        .ninit_done_ninit_done                     (ninit_done)                      //  output,   width = 1,                     ninit_done.ninit_done
    );


// debounce fpga_reset_n
debounce fpga_reset_n_debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (~ninit_done),
.data_in      (fpga_reset_n),
.data_out     (fpga_reset_n_debounced_wire)
);
defparam fpga_reset_n_debounce_inst.WIDTH = 1;
defparam fpga_reset_n_debounce_inst.POLARITY = "LOW";
defparam fpga_reset_n_debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam fpga_reset_n_debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @ (posedge system_clk_100_internal or posedge ninit_done)
begin
    if (ninit_done == 1'b1)
        fpga_reset_n_debounced <= 1'b0;
    else
        fpga_reset_n_debounced <= fpga_reset_n_debounced_wire;  
end

// Debounce logic to clean out glitches within 1ms
debounce debounce_inst (
.clk          (system_clk_100_internal),
.reset_n      (system_reset_n),  
.data_in      (fpga_button_pio),
.data_out     (fpga_debounced_buttons)
);
defparam debounce_inst.WIDTH = 2;
defparam debounce_inst.POLARITY = "LOW";
defparam debounce_inst.TIMEOUT = 10000;               // at 100Mhz this is a debounce time of 1ms
defparam debounce_inst.TIMEOUT_WIDTH = 32;            // ceil(log2(TIMEOUT))

always @(posedge system_clk_100_internal or negedge system_reset_n) begin
  if (~system_reset_n)
    heartbeat_count <= 25'd0;
  else
    heartbeat_count <= heartbeat_count + 25'd1;
end


endmodule


