// cpu.v

// Generated using ACDS version 23.2 94

`timescale 1 ps / 1 ps
module cpu (
		input  wire        clk,                          //                 clk.clk
		input  wire        reset_reset,                  //               reset.reset
		input  wire [15:0] platform_irq_rx_irq,          //     platform_irq_rx.irq
		output wire [31:0] instruction_manager_awaddr,   // instruction_manager.awaddr
		output wire [2:0]  instruction_manager_awsize,   //                    .awsize
		output wire [2:0]  instruction_manager_awprot,   //                    .awprot
		output wire        instruction_manager_awvalid,  //                    .awvalid
		input  wire        instruction_manager_awready,  //                    .awready
		output wire [31:0] instruction_manager_wdata,    //                    .wdata
		output wire [3:0]  instruction_manager_wstrb,    //                    .wstrb
		output wire        instruction_manager_wlast,    //                    .wlast
		output wire        instruction_manager_wvalid,   //                    .wvalid
		input  wire        instruction_manager_wready,   //                    .wready
		input  wire [1:0]  instruction_manager_bresp,    //                    .bresp
		input  wire        instruction_manager_bvalid,   //                    .bvalid
		output wire        instruction_manager_bready,   //                    .bready
		output wire [31:0] instruction_manager_araddr,   //                    .araddr
		output wire [2:0]  instruction_manager_arsize,   //                    .arsize
		output wire [2:0]  instruction_manager_arprot,   //                    .arprot
		output wire        instruction_manager_arvalid,  //                    .arvalid
		input  wire        instruction_manager_arready,  //                    .arready
		input  wire [31:0] instruction_manager_rdata,    //                    .rdata
		input  wire [1:0]  instruction_manager_rresp,    //                    .rresp
		input  wire        instruction_manager_rvalid,   //                    .rvalid
		output wire        instruction_manager_rready,   //                    .rready
		output wire [31:0] data_manager_awaddr,          //        data_manager.awaddr
		output wire [2:0]  data_manager_awsize,          //                    .awsize
		output wire [2:0]  data_manager_awprot,          //                    .awprot
		output wire        data_manager_awvalid,         //                    .awvalid
		input  wire        data_manager_awready,         //                    .awready
		output wire [31:0] data_manager_wdata,           //                    .wdata
		output wire [3:0]  data_manager_wstrb,           //                    .wstrb
		output wire        data_manager_wlast,           //                    .wlast
		output wire        data_manager_wvalid,          //                    .wvalid
		input  wire        data_manager_wready,          //                    .wready
		input  wire [1:0]  data_manager_bresp,           //                    .bresp
		input  wire        data_manager_bvalid,          //                    .bvalid
		output wire        data_manager_bready,          //                    .bready
		output wire [31:0] data_manager_araddr,          //                    .araddr
		output wire [2:0]  data_manager_arsize,          //                    .arsize
		output wire [2:0]  data_manager_arprot,          //                    .arprot
		output wire        data_manager_arvalid,         //                    .arvalid
		input  wire        data_manager_arready,         //                    .arready
		input  wire [31:0] data_manager_rdata,           //                    .rdata
		input  wire [1:0]  data_manager_rresp,           //                    .rresp
		input  wire        data_manager_rvalid,          //                    .rvalid
		output wire        data_manager_rready,          //                    .rready
		input  wire        timer_sw_agent_write,         //      timer_sw_agent.write
		input  wire [31:0] timer_sw_agent_writedata,     //                    .writedata
		input  wire [3:0]  timer_sw_agent_byteenable,    //                    .byteenable
		input  wire [5:0]  timer_sw_agent_address,       //                    .address
		input  wire        timer_sw_agent_read,          //                    .read
		output wire [31:0] timer_sw_agent_readdata,      //                    .readdata
		output wire        timer_sw_agent_readdatavalid, //                    .readdatavalid
		output wire        timer_sw_agent_waitrequest,   //                    .waitrequest
		input  wire        dm_agent_write,               //            dm_agent.write
		input  wire [31:0] dm_agent_writedata,           //                    .writedata
		input  wire [15:0] dm_agent_address,             //                    .address
		input  wire        dm_agent_read,                //                    .read
		output wire [31:0] dm_agent_readdata,            //                    .readdata
		output wire        dm_agent_readdatavalid,       //                    .readdatavalid
		output wire        dm_agent_waitrequest          //                    .waitrequest
	);

	cpu_intel_niosv_m_2243_ouuvxdq intel_niosv_m_inst (
		.clk                          (clk),                          //   input,   width = 1,                 clk.clk
		.reset_reset                  (reset_reset),                  //   input,   width = 1,               reset.reset
		.platform_irq_rx_irq          (platform_irq_rx_irq),          //   input,  width = 16,     platform_irq_rx.irq
		.instruction_manager_awaddr   (instruction_manager_awaddr),   //  output,  width = 32, instruction_manager.awaddr
		.instruction_manager_awsize   (instruction_manager_awsize),   //  output,   width = 3,                    .awsize
		.instruction_manager_awprot   (instruction_manager_awprot),   //  output,   width = 3,                    .awprot
		.instruction_manager_awvalid  (instruction_manager_awvalid),  //  output,   width = 1,                    .awvalid
		.instruction_manager_awready  (instruction_manager_awready),  //   input,   width = 1,                    .awready
		.instruction_manager_wdata    (instruction_manager_wdata),    //  output,  width = 32,                    .wdata
		.instruction_manager_wstrb    (instruction_manager_wstrb),    //  output,   width = 4,                    .wstrb
		.instruction_manager_wlast    (instruction_manager_wlast),    //  output,   width = 1,                    .wlast
		.instruction_manager_wvalid   (instruction_manager_wvalid),   //  output,   width = 1,                    .wvalid
		.instruction_manager_wready   (instruction_manager_wready),   //   input,   width = 1,                    .wready
		.instruction_manager_bresp    (instruction_manager_bresp),    //   input,   width = 2,                    .bresp
		.instruction_manager_bvalid   (instruction_manager_bvalid),   //   input,   width = 1,                    .bvalid
		.instruction_manager_bready   (instruction_manager_bready),   //  output,   width = 1,                    .bready
		.instruction_manager_araddr   (instruction_manager_araddr),   //  output,  width = 32,                    .araddr
		.instruction_manager_arsize   (instruction_manager_arsize),   //  output,   width = 3,                    .arsize
		.instruction_manager_arprot   (instruction_manager_arprot),   //  output,   width = 3,                    .arprot
		.instruction_manager_arvalid  (instruction_manager_arvalid),  //  output,   width = 1,                    .arvalid
		.instruction_manager_arready  (instruction_manager_arready),  //   input,   width = 1,                    .arready
		.instruction_manager_rdata    (instruction_manager_rdata),    //   input,  width = 32,                    .rdata
		.instruction_manager_rresp    (instruction_manager_rresp),    //   input,   width = 2,                    .rresp
		.instruction_manager_rvalid   (instruction_manager_rvalid),   //   input,   width = 1,                    .rvalid
		.instruction_manager_rready   (instruction_manager_rready),   //  output,   width = 1,                    .rready
		.data_manager_awaddr          (data_manager_awaddr),          //  output,  width = 32,        data_manager.awaddr
		.data_manager_awsize          (data_manager_awsize),          //  output,   width = 3,                    .awsize
		.data_manager_awprot          (data_manager_awprot),          //  output,   width = 3,                    .awprot
		.data_manager_awvalid         (data_manager_awvalid),         //  output,   width = 1,                    .awvalid
		.data_manager_awready         (data_manager_awready),         //   input,   width = 1,                    .awready
		.data_manager_wdata           (data_manager_wdata),           //  output,  width = 32,                    .wdata
		.data_manager_wstrb           (data_manager_wstrb),           //  output,   width = 4,                    .wstrb
		.data_manager_wlast           (data_manager_wlast),           //  output,   width = 1,                    .wlast
		.data_manager_wvalid          (data_manager_wvalid),          //  output,   width = 1,                    .wvalid
		.data_manager_wready          (data_manager_wready),          //   input,   width = 1,                    .wready
		.data_manager_bresp           (data_manager_bresp),           //   input,   width = 2,                    .bresp
		.data_manager_bvalid          (data_manager_bvalid),          //   input,   width = 1,                    .bvalid
		.data_manager_bready          (data_manager_bready),          //  output,   width = 1,                    .bready
		.data_manager_araddr          (data_manager_araddr),          //  output,  width = 32,                    .araddr
		.data_manager_arsize          (data_manager_arsize),          //  output,   width = 3,                    .arsize
		.data_manager_arprot          (data_manager_arprot),          //  output,   width = 3,                    .arprot
		.data_manager_arvalid         (data_manager_arvalid),         //  output,   width = 1,                    .arvalid
		.data_manager_arready         (data_manager_arready),         //   input,   width = 1,                    .arready
		.data_manager_rdata           (data_manager_rdata),           //   input,  width = 32,                    .rdata
		.data_manager_rresp           (data_manager_rresp),           //   input,   width = 2,                    .rresp
		.data_manager_rvalid          (data_manager_rvalid),          //   input,   width = 1,                    .rvalid
		.data_manager_rready          (data_manager_rready),          //  output,   width = 1,                    .rready
		.timer_sw_agent_write         (timer_sw_agent_write),         //   input,   width = 1,      timer_sw_agent.write
		.timer_sw_agent_writedata     (timer_sw_agent_writedata),     //   input,  width = 32,                    .writedata
		.timer_sw_agent_byteenable    (timer_sw_agent_byteenable),    //   input,   width = 4,                    .byteenable
		.timer_sw_agent_address       (timer_sw_agent_address),       //   input,   width = 6,                    .address
		.timer_sw_agent_read          (timer_sw_agent_read),          //   input,   width = 1,                    .read
		.timer_sw_agent_readdata      (timer_sw_agent_readdata),      //  output,  width = 32,                    .readdata
		.timer_sw_agent_readdatavalid (timer_sw_agent_readdatavalid), //  output,   width = 1,                    .readdatavalid
		.timer_sw_agent_waitrequest   (timer_sw_agent_waitrequest),   //  output,   width = 1,                    .waitrequest
		.dm_agent_write               (dm_agent_write),               //   input,   width = 1,            dm_agent.write
		.dm_agent_writedata           (dm_agent_writedata),           //   input,  width = 32,                    .writedata
		.dm_agent_address             (dm_agent_address),             //   input,  width = 16,                    .address
		.dm_agent_read                (dm_agent_read),                //   input,   width = 1,                    .read
		.dm_agent_readdata            (dm_agent_readdata),            //  output,  width = 32,                    .readdata
		.dm_agent_readdatavalid       (dm_agent_readdatavalid),       //  output,   width = 1,                    .readdatavalid
		.dm_agent_waitrequest         (dm_agent_waitrequest)          //  output,   width = 1,                    .waitrequest
	);

endmodule
